﻿
Imports Phidget22
Imports Phidget22.Events

Public Class SettingsForm
    Dim currentState As Integer = 0 '0 = save setting, 1 = revert to saved, 2 = revert to default
    Dim motorID As DeviceID

    Public Sub New(owner As Form)
        InitializeComponent()
        Me.Owner = owner
        Dim dummy As IntPtr = Me.Handle 'force the form to load before it's shown so we can call invoke on it
    End Sub

    Private Sub SettingsForm_FormClosing(sender As Object, e As FormClosingEventArgs) Handles MyBase.FormClosing
        If e.CloseReason = CloseReason.UserClosing Then
            Me.Hide()
            e.Cancel = True
        End If
        removeAdded()
    End Sub

    Public Sub ShowSettingsBox(state As Integer, deviceID As DeviceID)
        motorID = deviceID
        currentState = state

        For i As Integer = 0 To i < settingsList.Items.Count
            settingsList.SetItemChecked(i, False)
        Next
        If motorID = DeviceID.PN_DCC1000 Then
            settingsList.Items.Add("Current Limit")
            settingsList.Items.Add("Current Regulator Gain")
            settingsList.Items.Add("Encoder IO Mode")
        ElseIf motorID = DeviceID.PN_DCC1001 Then
            settingsList.Items.Add("Current Limit")
        ElseIf motorID = DeviceID.PN_DCC1100 Then
            settingsList.Items.Add("Stall Velocity")
        End If

        Me.Show()
        If state = 0 Then
            enterButton.Text = "Save Settings"
        ElseIf state = 1 Then
            enterButton.Text = "Revert to Saved Settings"
        ElseIf state = 2 Then
            enterButton.Text = "Revert to Defaults"
        End If
    End Sub

    Private Sub enterButton_Click(sender As Object, e As EventArgs) Handles enterButton.Click
        Dim owner As Form1 = CType(Me.Owner, Form1)
        owner.saveOrResetSettings(settingsList.CheckedItems, currentState)
        removeAdded()
    End Sub

    Private Sub selectAll_Click(sender As Object, e As EventArgs) Handles selectAll.Click
        For i As Integer = 0 To settingsList.Items.Count - 1
            settingsList.SetItemChecked(i, True)
        Next
    End Sub

    Private Sub deselectAll_Click(sender As Object, e As EventArgs) Handles deselectAll.Click
        For i As Integer = 0 To settingsList.Items.Count - 1
            settingsList.SetItemChecked(i, False)
        Next
    End Sub

    Sub removeAdded()
        'remove anything we added to the settingslist
        If motorID = DeviceID.PN_DCC1000 Then
            settingsList.Items.Remove("Current Limit")
            settingsList.Items.Remove("Current Regulator Gain")
            settingsList.Items.Remove("Encoder IO Mode")
        ElseIf motorID = DeviceID.PN_DCC1001 Then
            settingsList.Items.Remove("Current Limit")
        ElseIf motorID = DeviceID.PN_DCC1100 Then
            settingsList.Items.Remove("Stall Velocity")
        End If
    End Sub

End Class